<?
//                      
function node_error ($errno, $errstr, $errfile, $errline) {

if (!($errno & error_reporting())) return;

global $DEBUG;

if (!$DEBUG["php"]) {
@halt(104,"node_error: errno($errno), errstr($errstr), errfile($errfile), errline($errline)");
die();
exit -1;
}

switch ($errno) {
case E_ERROR:
echo "<b>ERROR</b> [$errno] $errstr<br>\n";
echo "  Fatal error in line ".$errline." of file ".$errfile;
echo ", PHP ".PHP_VERSION." (".PHP_OS.")<br>\n";
echo "Aborting...<br>\n";
exit -1;
break;
case E_WARNING:
echo "<b>WARNING</b> [$errno] $errstr,<br>\n in file $errfile<br>\n on line $errline<br>\n";
break;
case E_PARSE:
echo "<b>PARSE</b> [$errno] $errstr,<br>\n in file $errfile<br>\n on line $errline<br>\n";
break;
case E_NOTICE:
echo "<b>NOTICE</b> [$errno] $errstr,<br>\n in file $errfile<br>\n on line $errline<br>\n";
break;
default:
echo "Unkown error type: [$errno] $errstr,<br>\n in file $errfile<br>\n on line $errline<br>\n";
break;
}
}
?>
