<?

class NodeTableObject extends NodeObject {

var $d_tabId;
var $d_table;
var $d_db;
var $d_initTab;
var $d_tabStruct;

function NodeTableObject($id = 0, $table = "", $db = NULL) {
parent::NodeObject($id);
$this->setTable($table);
$this->setDBHandle($db);
$this->setID($id);
}

function _setID($id) {
$this->d_tabId = $id;
}

function getID() {
return $this->d_tabId;
}

function setTable($table) {
$this->d_table = $table;
$this->d_initTab = false;
}

function getTable() {
return $this->d_table;
}

function setDBHandle($handle) {
global $DB;
if (!$handle) $handle = $DB;
$this->d_db = $handle;
}

function getDBHandle() {
return $this->d_db;
}

function getTableStructure() { return $this->d_tabstruct; }

function getValueFields() {
if (!$this->_initTab()) return NULL;

$fields = array();
$tabstruct = $obj->getTableStructure();
foreach($tabstruct as $field=>$desc) {
if ($field == "id") continue;
if ($desc["type"] == "text" || $desc["type"] == "longtext") $fields[$field] = "textarea";
else if ($desc["type"] == "int") $fields[$field] = "int";
else if (substr($desc["type"], 0, 4) == "char" || substr($desc["type"], 0, 7) == "varchar") $fields[$field] = "text";
}

return $fields;
}

function getFormObject() { return new TableFormObject($this); }

function checkErrors() { return true; }

function _getNodeTable() { return $this->d_table; }

function _initTab() {
if ($this->d_initTab) return true;

if (!mydb_table_exists($this->d_table, $this->d_db)) return false;
$this->d_tabStruct = mydb_desc_table($this->d_table, $this->d_db);

$this->d_initTab = true;
return true;
}

}

class TableFormObject extends NodeFormObject {

function getFieldLabels() {
$obj =& $this->getEditObject();
if (!$obj->_initTab()) return NULL;

$fields = array();
$tabstruct = $obj->getTableStructure();
foreach($tabstruct as $field=>$desc) {
if ($field == "id") continue;
$fields[$field] = $field;
}

return $fields;
}

function isOptionalField($field) { return true; }

}

?>
