<?php

//                           
/*
           
                                  
                                  
  

//                           
            
       
                      
                      
   
       
                      
                     
   
  
*/

//                         
/*
                     
                     
                                                             
                      
                      
                            
                      
                      
                         
                              
                             
              
*/

class chart2D {

/////////////////////////////             /////////////////////////////
 //
 //                                                              
 //
 //                
 var $x_shift_caption = 0;
var $data=Array();
//                          
 var $color=Array();
//                        
 var $x_size = 500;
var $y_size = 250;
//                                     
 var $x_title;
var $y_title;
//                                 
 var $x_left_margin = 50;
//                                         
 var $x_right_margin = 20;
//                                       
 var $y_top_margin = 20;
//                                   
 var $y_bot_margin = 60;
//                  
 var $ticks = 10;
//                                                              
 var $nr_values;
//                                                                                
 var $max_y;
//                                
 var $min_y;
//                  
 var $col_back = 'aaaaaa';
//           
 var $col_grid = '000000';
//                      
 var $col_major = 'ff0000';
//                      
 var $first_header = 1;
//                                                      
 var $space = 0.15;
//                                                     
 var $get_next_10_base = 1;
//                                    
 var $show_values = 1;
//                                            
 var $decimals = 2;
//                                          
 var $grid_decimals = 2;
//            
 var $border = 1;
//////////////////////////                   //////////////////////////

//                              
 var $x_scale;
var $y_scale;
//                       
 var $x_tot_margin;
var $y_tot_margin;
//                       
 var $ticks_delta;
//              
 var $small_font = 2;
var $small_font_width = 6;
var $small_font_height = 10;
var $tiny_font = 3;

function chart2D ($data) {

//           
 $this->data = $data;

//                      
 if (!$max_y) {
reset($data);
$tmp_max = 0;
$tmp_min = 0;
while(list($k, $v) = each($data)) {
reset($v);
while(list($kk, $vv) = each($v)) {
if (is_array($vv)) {
$value = $vv[0];
} else {
$value = $vv;
}
if ($value > $tmp_max && is_numeric($value)) $tmp_max = $value;
if ($value < $tmp_min && is_numeric($value)) $tmp_min = $value;
}
}
$this->max_y = $tmp_max;
$this->min_y = $tmp_min;

} else {

$this->max_y = $max_y;
}
if (!$this->max_y) die("keine werte");
$this->min_y = $min_y;

//                                      
 if (!$nr_values) {
$this->nr_values = count($data);
} else {
$this->nr_values = $nr_values;
}
}

//                      
 function set ($name, $value) {
$this->{$name} = $value;
}

function error_check () {

//                                 
 if (!is_array($this->data)) {
$this->error = "data has wrong format.";
}

//                           
 if ($this->nr_values <= 0) {
$this->error = "Error nr_values($this->nr_values) <= 0";
}

//                          
 if ($this->max_y <= $this->min_y) {
$this->error = "Error max_y($this->max_y) <= min_y($this->min_y)";
}

//                   
 if ($this->x_size <= 0) {
$this->x_size = 100;
$this->error = "Error xsize <= 0";
}

//                   
 if ($this->y_size <= 0) {
$this->y_size = 20;
$this->error = "Error ysize <= 0";
}

//                  
 if ($this->x_left_margin < 0) {
$this->error = "Error x_left_margin < 0";
} else {
$this->x_left_margin = floor($this->x_left_margin);
}

//                   
 if ($this->x_right_margin < 0) {
$this->error = "Error x_right_margin < 0";
} else {
$this->x_right_margin = floor($this->x_right_margin);
}

//                 
 if ($this->y_top_margin < 0) {
$this->error = "Error y_top_margin < 0";
} else {
$this->y_top_margin = floor($this->y_top_margin);
}

//                    
 if ($this->y_bot_margin < 0) {
$this->error = "Error y_bot_margin < 0";
} else {
$this->y_bot_margin = floor($this->y_bot_margin);
}

if ($this->get_next_10_base) {
$this->max_y = pow(10, floor(log10($this->max_y)+1));
}

if ($this->get_next_10_div) {
$tmp=pow(10,floor(log10($this->max_y))-1);
$this->max_y = ceil(($this->max_y)/$tmp)*$tmp;
}

if (!(strlen($this->col_back) == 6 || strlen($this->col_back) == 7)) {
$this->error = "Error col_back has wrong format";
}

if (!(strlen($this->col_grid) == 6 || strlen($this->col_grid) == 7)) {
$this->error = "Error col_grid has wrong format";
}

if (!(strlen($this->col_major) == 6 || strlen($this->col_major) == 7)) {
$this->error = "Error col_major has wrong format";
}

$this->x_tot_margin = $this->x_left_margin + $this->x_right_margin;
$this->x_scale = ($this->x_size - $this->x_tot_margin - 10) / $this->nr_values ; 

//               
//                                     *                        

$this->y_tot_margin = $this->y_top_margin + $this->y_bot_margin;
$this->y_scale = ($this->y_size - $this->y_tot_margin) / $this->max_y;
if (!$this->max_y) die("keine werte");
$tmp = 16;
$i = 1;
if ($this->max_y) 
if ($this->max_y > 10) {
while ($tmp > 15) {
$i = $i*10;
$tmp = $this->max_y / $i;
}
if ($tmp < 5) $tmp = $tmp * 2;
} else {
while ($tmp < 3) {
$i = $i*0.1;
$tmp = $this->max_y / $i;
}
if ($tmp < 5) $tmp = $tmp * 2;
}
$this->ticks = $tmp;

if (!$this->ticks) $this->ticks = 1;
$this->ticks_delta = $this->max_y / $this->ticks;

}

//                                            
 function cc($color) {
if ($color[0] == "#") $color = substr($color,1);
$color=hexdec($color);
$red=($color&0xFF0000)>>16;
$green = ($color&0xFF00)>>8;
$blue = ($color&0xFF);
return array ($red, $green, $blue);
}

//                                    
 function ytr ($y) { 
return ($this->max_y * $this->y_scale + $this->y_top_margin - ($y * $this->y_scale));
}

//                                    
 function xtr ($x) {
return  ($this->x_left_margin + ($x * $this->x_scale));
}


function render () {
//                                                               
 $graph = ImageCreate($this->x_size, $this->y_size);

if ($this->error) {
$ieb = ImageColorAllocate($graph,0,0,0);
$ief = ImageColorAllocate($graph,255,255,255);
ImageRectangle($graph, $this->xtr(0), $this->ytr(0), $this->xtr($this->nr_values), $this->ytr($this->max_y), $ieb);
ImageString($graph, $this->small_font, 1, -($this->small_font_height / 2.0) + 10, $this->error, $ief);
return $graph;
}

//                                                                     
 /* 
                                
                                 
                                                                                           
                                                                                   
  */

//                        
 $c_back = $this->cc($this->col_back);
$c_grid = $this->cc($this->col_grid);
$c_major = $this->cc($this->col_major);

//                                                        
 $i_back = ImageColorAllocate($graph,$c_back[0],$c_back[1],$c_back[2]);
$i_dark = ImageColorAllocate($graph,floor($c_back[0]*.8),floor($c_back[1]*.8),floor($c_back[2]*.8));
$i_light = ImageColorAllocate($graph,floor($c_back[0]*1.2),floor($c_back[1]*1.2),floor($c_back[2]*1.2));

//            
 //                                         
 //                           

$i_grid = ImageColorAllocate($graph,$c_grid[0],$c_grid[1],$c_grid[2] );
$i_major = ImageColorAllocate($graph,$c_major[0],$c_major_g,$c_major_b);

if ($this->border) {
//                       
 ImageLine($graph, 0, 0,$this->x_size - 1, 0, $i_light);
ImageLine($graph, 1, 1,$this->x_size - 2, 1, $i_light);
ImageLine($graph, 0, 0,0,$this->y_size - 1, $i_light);
ImageLine($graph, 1, 1,1,$this->y_size - 2, $i_light);
ImageLine($graph, $this->x_size - 1, 0, $this->x_size - 1, $this->y_size - 1, $i_dark);
ImageLine($graph, 0, $this->y_size - 1, $this->x_size - 1, $this->y_size - 1, $i_dark);
ImageLine($graph, $this->x_size - 2, 1, $this->x_size - 2, $this->y_size - 2, $i_dark);
ImageLine($graph, 1, $this->y_size - 2, $this->x_size - 2, $this->y_size - 2, $i_dark);
}

//                       
 ImageRectangle($graph, $this->xtr(0), $this->ytr(0), $this->xtr($this->nr_values), $this->ytr($this->max_y), $i_grid);

ImageStringUp($graph, $this->small_font, 8, ($this->small_font_width * strlen($this->y_title) / 2.0) + $this->ytr($this->max_y / 2.0), $this->y_title, $i_grid);
ImageString($graph, $this->small_font, -($this->small_font_width * strlen($this->x_title) / 2.0) + $this->xtr($this->nr_values / 2.0), ($this->y_size - 3.0 * $this->small_font_height), $this->x_title, $i_grid);

$i = 0;
//                    
 while ($i <= $this->ticks){

$y_tmp = (DoubleVal($i) * $this->max_y / $this->ticks);

ImageLine($graph, (-10 + $this->xtr(0)), $this->ytr($y_tmp), $this->xtr(1),$this->ytr($y_tmp), $i_grid);

ImageLine($graph, ($this->xtr($this->nr_values) + 10), $this->ytr($y_tmp), $this->xtr($this->nr_values - 1), $this->ytr($y_tmp), $i_grid);

//                                    
 //                                                                                                  
 ImageLine($graph, $this->xtr(0), $this->ytr($y_tmp), $this->xtr($this->nr_values), $this->ytr($y_tmp), $i_light);

//              
 $ylab = sprintf("%6.".$this->grid_decimals."f %s",$this->ticks_delta*$i,"");

ImageString($graph, $this->small_font, ($this->x_left_margin - $this->small_font_width * strlen($ylab) - 8),( -($this->small_font_height / 2.0) + $this->ytr($y_tmp)), $ylab, $i_grid);

$i++;
}

//                                         
 $x = 0;
while ($x < $this->nr_values) {

//                    
 $grow = 0;

if (is_array($this->data[$x]))
while (list($k, $v) = each ($this->data[$x])) {


//                                         
 if (is_array($this->data[$x][$k])) {
$value = $this->data[$x][$k][0];
$color = $this->data[$x][$k][1];
} else {
$value = $this->data[$x][$k];
if ($this->color[$k]) {
$color = $this->color[$k];
} else {
$color = $this->col_major;
}
}

if ($this->first_header && $k == 0 ) {
if ($this->x_shift_caption) $xcaptionshift = ($x%$this->x_shift_caption)*$this->small_font_height;
else $xcaptionshift = 0;
ImageString($graph, $this->small_font,( -(strlen($value) * $this->small_font_width / 2.0) + $this->xtr(0.5 + $x)), ($this->y_size - $this->y_bot_margin + 0.5 * $this->small_font_height)+$xcaptionshift, $value, $i_grid);

} else {

$c_tmp = $this->cc($color);
$i_tmp = ImageColorAllocate($graph,$c_tmp[0],$c_tmp[1],$c_tmp[2]);

$max_grow = ($this->first_header)?count($this->data[$x]) - 1:count($this->data[$x]);

ImageFilledRectangle($graph, $this->xtr($this->space + ($grow / $max_grow) * (1 - 2 * $this->space) + $x), $this->ytr($value), $this->xtr($this->space + (($grow + 1) / $max_grow) * (1 - 2 * $this->space) + $x), $this->ytr(0), $i_tmp);
if ($this->show_values) {
$yval = sprintf("%6.".$this->decimals."f",$value);
///                                               
 //                                                                         /            *        *                                               *                                           
 }

//                          
 $grow++;
}
}

$x++;
}

return $graph;
}

function display() {
$this->error_check();
$image = $this->render();
Header("Content-Type: image/png"); 
ImagePng($image);
ImageDestroy($image);
}
}

?>
