<?

function mydb_pgsql_connect($database, $server = "localhost",$login,$pw = "") {
$db = @pg_pconnect("host=$server dbname=$database user=$login password=$pw");
if (!$db) halt(1,"<b>ERROR:</b> Could not connect to PostgreSQL Server $login@$server ($database)");
else return $db;
}

function mydb_pgsql_close($db) {
return @pg_close($db);
}

function mydb_pgsql_exec($sql,$db = 0, $halt = true) {
global $HALT,$DB;
if ($db) $mydb = $db;
else  $mydb = $DB;

if (is_array($mydb)) {
$handle = $mydb;
$mydb = $mydb["handle"];
}

$rs = pg_exec($mydb,$sql);
if (!$rs) {
if (!$HALT && $halt) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b>".pg_errormessage());
}
return $rs;
}

function mydb_pgsql_fetch($rs,$way = MYSQL_BOTH,$i = 0) {
return pg_fetch_array($rs, $i);
}

function mydb_pgsql_query($sql, $cache = false, $limit = 0, $db = 0, $way = MYSQL_BOTH) {

if ($cache && strtolower($sql[0]) == "s") return cache($sql, "pgsql", $limit, $db, $way);

global $DB, $DEBUG, $HALT, $QUERY_EFFORT, $QUERY_SPEED, $CACHE_SQL, $DEBUG, $USER_ID, $TIME, $TABLE_LOCK;
if (!$USER_ID) $USER_ID = 0;

if ($DEBUG["log_query"] && (strtolower($sql[0]) == "d" || strtolower($sql[0].$sql[1]) == "up") && !$TABLE_LOCK) {
$_sql = "INSERT INTO logrequest (user_id,request,timestamp) VALUES ($USER_ID,'".sqlslashes($sql)."',$TIME)";
mydb_pgsql_query($_sql, false);
}

if ($db) $mydb = $db; else $mydb = $DB;

if (!$mydb) return false;

if (is_array($mydb)) {
$handle = $mydb;
$mydb = $mydb["handle"];
}

if ($DEBUG["echo"]) $t1 = microtime();

$iid = 0;
$num = 0;

$cmd = strtolower(substr($sql,0,6));

if ($cmd == "select" && $limit > 0) $sql .= " LIMIT ".$limit;

$rs = pg_exec($mydb,$sql);
if (!$rs) {
if (!$HALT) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b>".pg_errormessage());
else return false;
}

if ($cmd == "insert") {
if (!$cache) $CACHE_SQL = Array();
if (eregi("^INSERT +INTO +([^ ]+) ",$sql,$regs)) {
$qry = "SELECT last_value FROM ".$regs[1]."_id_seq";
$riq = @pg_exec($mydb,$qry);
if ($riq && @pg_numrows($riq) > 0) {
$r = @pg_fetch_array($riq,0);
$iid = $r["last_value"];
}
}
$DEBUG["insert"]++;
}

if ($rs && ($cmd == "select" || substr($cmd,0,4) == "show")) {
$DEBUG["select"]++;
$num = pg_numrows($rs);
$i=0;
while ($rs && $i < $num) {
$row = pg_fetch_array($rs,$i);
$arr[] = $row;
$i++;
}
}

if ($cmd == "update") {
if (!$cache) $CACHE_SQL = Array();
$DEBUG["update"]++;
}
if ($cmd == "delete") {
if (!$cache) $CACHE_SQL = Array();
$DEBUG["delete"]++;
}

$result["arr"] = $arr;
$result["num"] = $num;
$result["iid"] = $iid;

if ($DEBUG["echo"]) {
$t2 = microtime();
$tmp = calctime($t1,$t2,5);
$QUERY_EFFORT += $tmp;
if ($DEBUG["db"]) echo "<br>\n$sql\n<br>$tmp\n<br>";
}

return $result;
}

function mydb_pqsql_create_database($database,$db) {
return false;
}

?>
