<?php

class EventObject
{
var $d_properties = array();
var $d_modified = NULL;

function EventObject( $properties=NULL, $modified = NULL)
{
if ( is_array($properties) )
$this->d_properties = $properties;
$this->d_modified = $modified;
}

/**
  *                               
  **/
function getCacheKey() {
$arr = $this->d_properties;
ksort($arr);
return serialize($arr);
}

function getProperty( $name )
{
if ( isset( $this->d_properties[$name] ) )
return $this->d_properties[$name];
return NULL;
}

function getModified() {
return $this->d_modified;
}
}

class EventChildObject extends EventObject {

var $d_childId;
var $d_childType;

function EventChildObject( $childType, $childId = NULL, $properties = NULL) {
parent::EventObject($properties);
$this->d_childType = $childType;
$this->d_childId = $childId;
}

function getEventChildId() {
return $this->d_childID;
}

function getEventChildType() {
return $this->d_childType;
}
}

?>
