<?

class GUIFramesetObject extends GUIVFrameObject  {

function GUIFramesetObject() {
parent::GUIVFrameObject("frameset");
$this->setNoJSEnabled( TRUE );
$this->setCSSEnabled( FALSE );
$this->setBodyEnabled( FALSE );
}


}


class GUITreeObject extends GUIVFrameObject  {

function GUITreeObject() {
parent::GUIVFrameObject("tree");
}

}

class GUIAssObject extends GUIVFrameObject  {

function GUIAssObject() {
parent::GUIVFrameObject("ass");
}

function getPassiveHeader( &$main ) {
if ($main->getGUIName() == "main") {
node_include("related_links");
global $NODERELATED, $NODEVIEWS, $DO;
if (is_array($NODERELATED)) load_related($NODERELATED[$DO]);
if (is_array($NODEVIEWS)) load_related($NODEVIEWS[$DO],$NODEVIEWS["${DO}_title"], $NODEVIEWS["${DO}_active"]);
}
}

}

class GUIMenuObject extends GUIVFrameObject  {

var $d_statusTags = array();

function GUIMenuObject() {
global $FEATURE;
parent::GUIVFrameObject("menu");
node_class( "progressstatusinfo" );
if ($FEATURE["progressbar"]) $this->addInfoObject( new ProgressStatusInfo() );
$this->addInfoObject( new StatusMessage() );
}

function getFramePrefix() {
return "top.menu";
}

function getPassiveHeader( &$main ) {
//                                                                                         
 if ( $main->getGUIName() == "main" )
{
$main->includeJS("layer");
$main->includeJS("menu1");
}
//                                                                                        
 /*                                                 */
$menuFrame = "top.menu";

$header = "\n" . '<script language="Javascript">' . "\n";
$header .= "if ( $menuFrame ){
	if ( $menuFrame.write_status ) {
";

$msgs =& $this->_getMessages();
reset($msgs);
while (list($key,$msg) = each($msgs)) {
$name = get_class( $msg ) . "_$key";
$info = $this->_buildInfo($msg);
$header .= $msg->getPassiveHeader($this);
$html = $info["html"];
$header .= "	$menuFrame.write_status('$name', '".cleannl2bnl(addslashes($html))."');\n";
}
$header .= "}\n}\n";
$header .= '</script>' . "\n";
return $header;
}

function getPassiveHTML( &$main ) {
node_include("load_menu");
if ( $main->getGUIName() == "main" )
{
generate_menujs();
}
}

function getHeader() {
$this->includeJS( "layer" );
//                                                           
 global $JS;
$JS .= "
	function write_status(status, value) {
		l = get_layer(status);
		write_layer(l, value);
		show_layer(l);
	}
		";
$header = $this->_getParentHeader();
return $header;
}

function getHTML() {
$html = $this->_getParentHTML();
//             
 $msgs =& $this->_getMessages();

//                                 
 $layer_left = 2;
$layer_width = 150;
$layer_top = 3;
$js = "";
reset($msgs);
while (list($key, $msg) = each($msgs)) {
$status = $this->_buildInfo($msg);
$name = get_class( $msg ) . "_$key";
$msgInfo = $msg->getInfo();
if ($msgInfo["divstyle"]) {
$style = $msgInfo["divstyle"];
} else {
$style = "position:absolute;left:".$layer_left."px;top:".$layer_top."px;width:".$status["width"]."px;visibility:visible;";
}

$html .= "<div id=\"$name\" style=\"$style\">".$status["html"]."</div>\n";
$layer_left += ($status["width"] + 20);

$js .= $this->_buildObjectJS($msg);
}											

if ($js) $html .= "<script type=\"text/javascript\">\n$js\n</script>\n";

///                                                                      
 

return $html;
}

/**
  *                                 
  * 
  *                         
  *         
  **/
function addInfoObject( &$sInfo ) {
$this->d_statusTags[] =& $sInfo;
}


//                                                       

function& _getMessages() {
return $this->d_statusTags;
}


function _buildObjectJS($msgs) {
$ret = "";

if (!is_array($msgs)) $msgs = array($msgs);
foreach ($msgs as $msg) {
$ret .= $msg->getJavascript($this);
}

return $ret;
}

function _buildInfo($msgs) {
global $STAG_PREFIX;

if (!is_array($msgs)) $msgs = array($msgs);
if ( !count($msgs) ) return "";

$rep = false;
$width = 0;
foreach ($msgs as $msg) {
if ($rep) $ret .= "</td><td>".img("",0,0,0,10,1)."</td><td valign=middle>";
$rep = true;

$info = $msg->getInfo();
$width += $msg->getWidth();
//                                  
 
if ($info["icon"]) $ret .= img($info["icon"],0, $info["icon_title"]).img("",0,0,0,7,1)."</td><td nowrap valign=middle>";
$ret .= $info["text"];
}

$ret .= "</td></tr></table>";

return array( "width"=>$width, "html"=>$ret);
}

}

?>
