<?
//                          
//                                                                                 
//                                                 
$W_TIMER["ontime"] = true;

$W_EVENT["ontime"]["name"] = $DIC[1608];
$W_EVENT["ontime"]["input"][] = "time";
$W_EVENT["ontime"]["input"][] = "lasttime";
$W_EVENT["ontime"]["trigger"][] = "time";
$W_EVENT["ontime"]["trigger_on"][] = "time";
$W_EVENT["ontime"]["output"][] = "time";

if ($FEATURE["workflow_random"]) {
$W_EVENT["onrandom"]["name"] = $DIC[1609];
$W_EVENT["onrandom"]["input"][] = "rand_int";
$W_EVENT["onrandom"]["trigger"][] = "rand_int";
$W_EVENT["onrandom"]["trigger_on"][] = "rand_int";
$W_EVENT["onrandom"]["output"][] = "rand_int";

$W_REACTION["create_rand"]["name"] = $DIC[1610];
$W_REACTION["create_rand"]["input"][] = "max_int";
$W_REACTION["create_rand"]["output"][] = "rand_int";
$W_REACTION["create_rand"]["reactionfunc"] = "reaction_gen_rand";
$W_REACTION["create_rand"]["triggered"][] = "onrandom";
}

$W_REACTION["send_msg"]["name"] = $DIC[1611];
$W_REACTION["send_msg"]["input"][] = "user_id";
$W_REACTION["send_msg"]["input"][] = "message";
$W_REACTION["send_msg"]["output"][] = "user_id";
$W_REACTION["send_msg"]["output"][] = "message";
$W_REACTION["send_msg"]["output"][] = "msg_id";
$W_REACTION["send_msg"]["reactionfunc"] = "reaction_send_msg";

$W_REACTION["show_msg"]["name"] = $DIC[1612];
$W_REACTION["show_msg"]["input"][] = "message";
$W_REACTION["show_msg"]["output"][] = "message";
$W_REACTION["show_msg"]["reactionfunc"] = "reaction_show_msg";

$W_TYPE["user_id"]["name"] = $DIC[349];
$W_TYPE["user_id"]["type"] = "id";
$W_TYPE["user_id"]["input"] = "selector";
$W_TYPE["user_id"]["init"] = "init_user_selector";

$W_TYPE["message"]["name"] = $DIC[1613];
$W_TYPE["message"]["type"] = "text";
$W_TYPE["message"]["input"] = "text";
$W_TYPE["message"]["accept"][] = "text";

$W_TYPE["msg_id"]["name"] = $DIC[1614];
$W_TYPE["msg_id"]["type"] = "id";

$W_TYPE["max_int"]["name"] = $DIC[1615];
$W_TYPE["max_int"]["type"] = "int";
$W_TYPE["max_int"]["input"] = "int";

$W_TYPE["rand_int"]["name"] = $DIC[1616];
$W_TYPE["rand_int"]["type"] = "int";
$W_TYPE["rand_int"]["input"] = "int";

$W_TYPE["time"]["alias"][] = "lasttime";
$W_TYPE["time"]["name"] = $DIC[1558];
$W_TYPE["time"]["type"] = "time";
$W_TYPE["time"]["input"] = "time";

$W_TYPE["period"]["name"] = $DIC[1604];
$W_TYPE["period"]["type"] = "period";
$W_TYPE["period"]["input"] = "period";

function init_user_selector($prefix,$info) {
return new user_selector($prefix,$info);
}

function reaction_send_msg($reaction, $props, $id,&$handled) {
global $USER_ID;

$msg = $props["message"];
$uid = $props["user_id"];

//                                                                                
 //                                     

if (!$msg || !$uid) return $props;

$props["msg_id"] = msg($msg, $uid, $USER_ID);

$handled = true;

return $props;
}

function reaction_gen_rand($reaction, $input, $id, &$handled) {

$max = ($input["max_int"])?$input["max_int"]:1;

$input["rand_int"] = rand(0,$max);

trigger_event("onrandom",$input, $id);

return $input;
}

function reaction_show_msg($reaction, $input, $id, &$handled) {
global $JS;

if ($input["message"]) $JS .= "alert(\"".addslashes(str_replace("\n","\\n",$input["message"]))."\");\n";

return $input;
}

?>
